mod dijkstra;
mod merge_sort;
mod min_cut;
mod quick_sort;
mod ssc;
mod util;

use std::cmp::min;

use crate::dijkstra::dijkstra;
use crate::merge_sort::merge_sort_inversions;
use crate::min_cut::min_cut;
use crate::quick_sort::quick_sort;
use crate::ssc::ssc;

#[allow(dead_code)]
fn c1a2() {
    let vec = util::read_to_vector("data/c1a2.txt").unwrap();
    let (_sorted, inversions) = merge_sort_inversions(vec);
    println!("c1a2={:?}", inversions);
}

#[allow(dead_code)]
fn c1a3() {
    let mut vec = util::read_to_vector("data/c1a3.txt").unwrap();
    let mut comp_acc: usize = 0;
    quick_sort(&mut vec, &mut comp_acc);
    println!("c1a3={:?}", comp_acc);
    // 1: 162085, 2: 164123, 3: 138382
}

#[allow(dead_code)]
fn c1a4() {
    let g = util::read_to_graph("data/c1a4.txt").unwrap();
    let mut smallest_min_cut = u32::MAX;
    let iterations = g.nodes.len().pow(1);
    for _ in 0..iterations {
        let new_min_cut = min_cut(g.clone());
        if new_min_cut < smallest_min_cut {
            smallest_min_cut = new_min_cut;
        }
    }
    // 17
    println!("c1a4={:?}", smallest_min_cut);
}

#[allow(dead_code)]
fn c2a1() {
    // I have not checked in the graph file, because it has 70MB. This is a tiny test example.
    let g = util::read_to_directed_graph("data/c2a1_test.txt").unwrap();
    let sizes = ssc(g.0, g.1);
    let max_size = min(sizes.len(), 5);
    println!("{:?}", &sizes[0..max_size]);
    // [434821, 968, 459, 313, 211]
}

#[allow(dead_code)]
fn c2a2() {
    let mut requested_vertices: Vec<usize> = vec![7, 37, 59, 82, 99, 115, 133, 165, 188, 197];
    let mut g = util::read_to_directed_weighted_graph("data/c2a2.txt").unwrap();
    dijkstra(&mut g);
    for i in 0..requested_vertices.len() {
        requested_vertices[i] = g.distance[requested_vertices[i] - 1];
    }
    println!("{:?}", requested_vertices);
    // [2599, 2610, 2947, 2052, 2367, 2399, 2029, 2442, 2505, 3068]
}

fn main() {
    // c1a2();
    // c1a3();
    // c1a4();
    // c2a1();
    c2a2();
}
